#include	"stdio.h"

FILE	*extents, *eqns;

void	load_wards();
void	load_data();

main()
{
	if (((extents = fopen("extents.env","w")) == 0) || ((eqns = fopen("eqns.env","w")) == 0)) {
		fprintf(stderr,"Cannot open output\n");
		exit(1);
	}
	load_wards();
	load_data("1978.raw",1978);
	load_data("1982.raw",1982);
	load_data("1986.raw",1986);
	load_data("1990.raw",1990);
	fclose(extents);
	fclose(eqns);
}

void	load_wards()
{
	FILE	*wards;
	int	ward_no, size;
	char	name[24], const[24];

	if ((wards = fopen("wards","r")) == 0) {
		fprintf(stderr,"Cannot Open `wards' (r)\n");
		exit(1);
	}
	fprintf(eqns,"\"// loading ward data\";\n");
	while (fscanf(wards,"%d %*c %[^\,] %*c %d %*c %s",&ward_no,name,&size,const) != EOF) {
		fprintf(extents,"_value W%d == Ward;\n",ward_no);
		fprintf(extents,"_value %s == WardName;\n",name);
		fprintf(extents,"_value %s == Const;\n",const);
		fprintf(eqns,"_include |ward_details (W%d,%s,%d,%s);\n",ward_no,name,size,const);
	}
	fclose(wards);
}

void	load_data(name,year)
char	*name;
int	year;
{
	FILE	*data;
	int	ward_no, votes;
	char	candidate[24], party[24];

	if ((data = fopen(name,"r")) == 0) {
		fprintf(stderr,"Cannot Open `%s' (r)\n",name);
		exit(1);
	}
	fprintf(eqns,"\"// loading data for %d\";\n",year);
	fprintf(eqns,"_include |election %d;\n",year);
	while (fscanf(data,"%d %*c %[^\,] %*c %[^\,] %*c %d",&ward_no,candidate,party,&votes) != EOF) {
		fprintf(extents,"_value %s == Party;\n",party);
		fprintf(extents,"_value %s == Cand;\n",candidate);
		fprintf(eqns,"_include |ward_results (W%d,%d,%s,%s,%d);\n",ward_no,year,candidate,party,votes);
	}
	fclose(data);
}
