#include	"stdio.h"

FILE	*eqns;

void	load_wards();
void	load_data();

main()
{
	if ((eqns = fopen("eqns.p","w")) == 0) {
		fprintf(stderr,"Cannot open output\n");
		exit(1);
	}
	load_wards();
	load_data("1978.raw",1978);
	load_data("1982.raw",1982);
	load_data("1986.raw",1986);
	load_data("1990.raw",1990);
	fclose(eqns);
}

void	load_wards()
{
	FILE	*wards;
	int	ward_no, size;
	char	name[24], const[24];

	if ((wards = fopen("wards","r")) == 0) {
		fprintf(stderr,"Cannot Open `wards' (r)\n");
		exit(1);
	}
	while (fscanf(wards,"%d %*c %[^\,] %*c %d %*c %s",&ward_no,name,&size,const) != EOF)
		fprintf(eqns,"ward_details(\'W%d\',\'%s\',%d,\'%s\').\n",ward_no,name,size,const);
	fclose(wards);
}

void	load_data(name,year)
char	*name;
int	year;
{
	FILE	*data;
	int	ward_no, votes;
	char	candidate[24], party[24];

	if ((data = fopen(name,"r")) == 0) {
		fprintf(stderr,"Cannot Open `%s' (r)\n",name);
		exit(1);
	}
	while (fscanf(data,"%d %*c %[^\,] %*c %[^\,] %*c %d",&ward_no,candidate,party,&votes) != EOF)
		fprintf(eqns,"ward_result(\'W%d\',%d,\'%s\',\'%s\',%d).\n",ward_no,year,candidate,party,votes);
	fclose(data);
}
