# pragma interface

class	uustack {		//	Unique Unsigned Stack
private:
	struct	node {
		unsigned	data;
		node		*next;
	};
	node	*top;
public:
		uustack()
	{
		top = (node*) 0;
	}

		~uustack()
	{
		while (!empty()) pop();
	}

	int	empty()
	{
		return top == (node*) 0;
	}

	void	push(register unsigned val)
	{
		for (register node *ptr = top; ptr && ptr->data != val; ptr = ptr->next);
		if (!ptr) {
			if (! int(ptr = new node)) {
				cerr << "uustack::push\n";
				exit(1);
			}
			ptr->data = val;
			ptr->next = top;
			top = ptr;
		}
	}

	unsigned	pop()
	{
		node		*next;
		unsigned	data;

		if (empty()) {
			cerr << "uustack::pop\n";
			exit(1);
		}
		next = top->next;
		data = top->data;
		delete top;
		top = next;
		return data;
	}
};

