# include	"../header.h"
# include	"tc/tc.h"
# include	"df/df.h"
# include	"hf/hf.h"
# include	"db.h"

db	*database;

const	int	TestSize =	25000;
const	int	SelectorCt =	5;

void	test0()
{
	int	k = 0;
	field	saf[10];

	cerr << "Test 0 -";
	for (int i = 0; i < 100; ++i)
		for (int j = 0; j < 100; ++j) {
			saf[0].set(Size2,4);
			saf[1].set(Con,database->str_to_id("Tuple2"));
			saf[2].set(Int,i);
			saf[3].set(Int,j);
			k += database->insert("skewed",saf);
			if ((k % 10000) == 0)
				cerr << "*";
			else if ((k % 1000) == 0)
				cerr << "+";
		}
	cerr << "\t(Inserted " << k << ")\n";
}

void	test1()
{
	field	saf[10];
	int	i;
	char	sel[MaxString];

	srand(0);
	for (i = 0; i < TestSize; ) {
		sprintf(sel,"selector%d",rand() % SelectorCt);
		saf[0].set(Size2,3);
		saf[1].set(Var,rand() % 997);
		saf[2].set(Int,rand() % 997);
		if (database->insert(sel,saf)) {
			++i;
			if ((i % 10000) == 0)
				cerr << "*";
			else if ((i % 1000) == 0)
				cerr << "+";
		}
	}
	cerr << "\t(Inserted " << i << ")\n";
}

void	test2()
{
	field	results[TestSize*3], saf[10], *end;
	int	i, j, k;
	char	sel[MaxString];

	for (i = j = k = 0; i < SelectorCt; ++i) {
		sprintf(sel,"selector%d",i);
		saf[0].set(Any,0);
		end = database->fetch(sel,saf,results,&results[TestSize*3]);
		j += k = (end - results) / 3;
		cerr << "Fetch from " << i << " --> " << k << "\n";
	}
	cerr << "Total --> " << j << "\n";
}

void	test3()
{
	field	saf[10];
	int	i;
	char	sel[MaxString];

	for (i = 0; i < SelectorCt; ++i) {
		sprintf(sel,"selector%d",i);
		saf[0].set(Any,0);
		if (database->remove(sel,saf))
			cerr << "Remove from " << i << " --> True\n";
		else	cerr << "Remove from " << i << " --> False\n";
	}
}

int	main()
{
	database = new db("data");
	test0();
	test1();
	test2();
	test3();
	test2();
	return(0);
}
