# pragma interface

const	int	DFDataSize =		600;		// Page Size
const	int	DFPoolSize =		500;		// Buffer Size in pages

class	DFPage { public :
	int	free;
	int	info;
	field	data[DFDataSize];

        DFPage() {} ;
};

struct	DiskPage {
	int	free;
	int	info;
	int	value[DFDataSize];
	char	tag[DFDataSize];
};

struct	Buff { 
	int	access;
	int	modified;
	int	pno;
	DFPage	page;
};

class df {
private:
	fstream	file;

	field	saf[DFDataSize];				//	Temporary working space

	int	page_count;
	int	access;
	Buff	pool[DFPoolSize];

	int	copy(field*, field*);				//	Record Handling
	int	match(field*, field*);

	Buff*	load(int);					//	I/O operations
	void	read(int, DFPage&);
	void	write(int, DFPage&);

public:
		 df(const char* dname, const char* fname);
		~df();

	int	alloc(int info);
	int	ginfo(int pno)
	{
		return load(pno)->page.info;
	};
	int	pinfo(int pno, int info)
	{
		Buff	*b = load(pno);
		b->modified = True;
		return b->page.info = info;
	};

	field*	fetch(int pno, field *rec, field *res, field *end);
	int	insert(int pno, field *rec);
	int	remove(int pno, field *rec);
};

