# pragma implementation

# include	"../../header.h"
# include	"tc.h"

ostream& tc::print(ostream& s,field token)
{
	switch (token.tag()) {
	case Pre :
		return s << "*Prim" << token.value() << "*";
	case Int :
		return s << token.value();
	case Real :
		return s << token.valuef();
	case Chr :
		return s << "'" << ((char) token.value()) << "'";
	case Sel1 :
	case Sel2 :
	case Con :
	case Str :
	case Var :
		return s << id_to_str(token.value());
	case TCon :
		return s << "Some" << token.value();
	case TVar :
		return s << "type" << token.value();
	default :
		return s << "**" << token.tag() << "**";
	}
}

const char* tc::id_to_str(int id)
{
	int	pno = page_of_id(id), offset = offset_of_id(id);
	TCPage	p;

	read(pno,p);
	return &p.data[offset];
}

int	tc::str_to_id(const char* value)
{
	int		pno = hash_string(value);
	register int	i, sz = strlen(value);
	TCPage		p;

	read(pno,p);
	for (i = 0; p.data[i] != '\0' && strcmp(&p.data[i],value) != 0; i += strlen(&p.data[i])+1);
	if (p.data[i] == '\0') {
		check((i + sz + 1) < TCPageSize,"tc::store_value");
		(void) strcpy(&p.data[i],value);
		write(pno,p);
	}
	return	id_to_token(pno,i);
}

int	tc::hash_string(const char* string)
{
	register unsigned int code = 0, i;

	for (i = 0; string[i]; i++)
		code += (string[i] & 0xF) << (4 * (i % 4));
	return	code%TCSize;
}

	tc::tc(const char* dname, const char* fname)
{
	char	name[TCPageSize];
	int	i;
	TCPage	p;

	sprintf(name,"%s/%s",dname,fname);
	f.open(name,(ios::in)|(ios::out)|(ios::nocreate));
	if (f.rdstate() != ios::goodbit) {
		f.open(name,(ios::in)|(ios::out));
		for (i = 0; i < TCPageSize; ++i)
			p.data[i] = '\0';
		for (i = 0; i < TCSize; ++i)
			write(i,p);
	}
}

	tc::~tc()
{
	f.close();
	check(f.rdstate() == ios::goodbit,"tc::~tc");
}

