# pragma interface

const	int	TCSize =		503;		// prime & less than 0xFFFF
const	int	TCPageSize =		512;		// less than 0xFFFF

struct TCPage {
	char data[TCPageSize];
};

class	tc {
private:
	fstream	f;

	void	read(int pno,TCPage& page)
		{
			f.seekg(pno*sizeof(TCPage),ios::beg);
			f.read((char*) &page, sizeof(TCPage));
			check(f.rdstate() == ios::goodbit,"tc::read");
		};

	void	write(int pno,TCPage& page)
		{
			f.seekp(pno*sizeof(TCPage),ios::beg);
			f.write((char*) &page, sizeof(TCPage));
			check(f.rdstate() == ios::goodbit,"tc::write");
		};

	int	id_to_token(int pno, int offset)
		{
			return (pno & 0xFFFF) | ((offset & 0xFFFF) << 16);
		};

	int	page_of_id(int id)
		{
			return (id & 0xFFFF);
		};

	int	offset_of_id(int id)
		{
			return (id >> 16) & 0xFFFF;
		};

	int	hash_string(const char*);

public:
		 tc(const char* dname, const char* fname);
		~tc();

	int	str_to_id(const char*);
	const char* id_to_str(int);

	ostream&	print(ostream& s,field f);
};


