# pragma implementation

# include	"../header.h"
# include	"../db/tc/tc.h"
# include	"../db/df/df.h"
# include	"../db/hf/hf.h"
# include	"../db/db.h"
# include	"../hp/cell.h"
# include	"../hp/cstack.h"
# include	"../hp/hp.h"
# include	"../expr/expr.h"
# include	"../user/user.h"
# include	"../type/type.h"
# include	"eval.h"

# include	"show.C"

void	eval::profile_set(field fun)
{
	for (int i = 0; i < profile_top && profile_fun[i] != fun; ++i);
	if (i == profile_top) {
		profile_fun[i] = fun;
		profile_ct[i] = 0;
		profile_top += 1;
	} 
	profile_ct[i] += 1;
}

void	eval::profile_rep()
{
	cout << "Calls:\tFunction:" << endl;
	for (int i = 0; i < profile_top; ++i)
		cout << profile_ct[i] << "\t" << heap->make(profile_fun[i]) << endl;
}

int	eval::normalise(cell* c)
{
	int	result = evaluate(c);

	for (heap->claim(c); result && c->tag() == App; c = c->left())
		result &= normalise(c->right());
	heap->release();
	return result;
}

int	eval::evaluate(cell* c)
{
	cell	*tip;
	int	ok, base = pending.used();

	heap->claim(c);
	for (ok = pending.push(c); !interrupt && ok && pending.used() > base; ) {
		c = pending.pop();
//	cout << "Processing (eval) " << c << endl;
		switch ((tip = spine.unwind(c))->tag()) {
		case Sel1 :
			profile_set(tip->data());
			if (spine.used() == 2)
				ok = process_extsel(tip->data(),c);
			else {
				cout << "<< function >>" << endl;
				ok = False;
			}
			break;
		case Sel2 :
			profile_set(tip->data());
			if (spine.used() == 1)
				ok = process_all(tip->data(),c);
			else {
				cout << "<< function >>" << endl;
				ok = False;
			}
			break;
		case Var :
			profile_set(tip->data());
			ok = pending.push(c) && process_lhs(tip->data(),c);
			break;
		case Pre :
			profile_set(tip->data());
			ok = pending.push(c) && exec(tip->value(),spine,pending);
			break;
		}
	}
	for (;pending.used() > base; pending.pop());
	heap->release();
	return ok && !interrupt;
}

# include	"all.C"
# include	"extsel.C"
# include	"function.C"
