//	show(rhs)	causes rhs to be evaluated and printed.
//	-------		rhs does not have to be protected.

int	eval::show(cell* rhs)
{
	cell	*type, *lhs = heap->make(Var,database->str_to_id("_print"));
	char	string[MaxString];
	field	saf[1];
	int	res;

	expressions->remove_eqns(lhs->data());
	expressions->insert_eqn(lhs->data(),rhs);
	types.cascade();
	type = types.fetch(lhs,True);
	if (res = type->data() != WrongConst && types.first_order(type)) {
		profile_top = 0;
		res = show_any(lhs);
		cout << endl << flush;
	}
	else	cout << "<< expression has type `" << type << "' >>" << endl << flush;
	for (field *curr = sels; curr < end; ++curr) {
		strcpy(string,database->id_to_str(curr->value()));
		saf[0].set(Any,0);
		database->remove(string,saf);
	}
	end = sels;
	return	res;
}

int	eval::show_any(cell* exp)
{
	if (evaluate(exp) && !interrupt) {
		switch (exp->tag()) {
		case Chr :
		case Con :
		case Int :
		case Real :
		case Str :
		case TCon :
		case TVar :
			cout << exp << flush;
			return True;
		default :
			cell* tip = exp->tip();
			if (strncmp("Tuple",database->id_to_str(tip->value()),5) == 0) {
				cout << "(" << flush;
				if (!show_tuple(exp))
					return False;
				cout << "\b)" << flush;
				return True;
			}
			else if (tip->data() == ConsConst) {
				cout << "[" << flush;
				if (!show_list(exp))
					return False;
				cout << "\b]" << flush;
				return True;
			}
			else if (tip->data() == FunConst) {
				cout << exp;
				return True;
			}
			else if (tip->data() == ListConst) {
				cout << exp;
				return True;
			}
			else {
				cout << "(" << flush;
				if (!show_const(exp))
					return False;
				cout << "\b)" << flush;
				return True;
			}
		}
	}
	return False;
}

int	eval::show_const(cell* exp)
{
	int	i;

	for (i = 0; exp->tag() == App; ++i, exp = exp->left())
		heap->claim(exp->right());
	heap->claim(exp);
	for (++i; i; --i)
		if (!show_any(heap->release()))
			return False;
		else	cout << " " << flush;
	return True;
}

int	eval::show_list(cell* exp)
{
	while (exp->tip()->data() != NilConst) {
		heap->claim(exp->right());
		if (!show_any(exp->left()->right()))
			return False;
		cout << "," << flush;
		if (!evaluate(exp = heap->release()) || interrupt)
			return False;
	}
	return True;
}

int	eval::show_tuple(cell* exp)
{
	int	i;

	for (i = 0; exp->tag() == App; ++i, exp = exp->left())
		heap->claim(exp->right());
	while (i--)
		if (!show_any(heap->release()))
			return False;
		else	cout << "," << flush;
	return True;
}

