# pragma interface

const	int	Same =		0;
const	int	Less = 		1;
const	int	More = 		2;
const	int	Incomparable =	3;

extern	hp	*heap;
extern	db	*database;
extern	int	heap_size;

class expr {
private:
	field*	records;

	int	next;
	field	*ptr;
	field	fun_name[MaxFunctions];
	field*	fun_locn[MaxFunctions];
	field	executable_code[MaxFunctions*MaxCells];

	void	set_dependency(field fun, field *rec, int incr);
	field*	ast_rec(cell*,field*);
	void	rec_ast(field*);

	field*	compile_ast(cell*,field*);
	field*	compile_arg(cell*,field*);
	field*	compile_rhs(cell*,field*,field*,field*);

	int	order(cell*, cell*);
	int	order_args(cell*, cell*);
	int	load(char*, field, int);

	cell*	replace_abst(cell* eqn);
	cell*	replace_zf(cell* eqn, const cstack& args);
	void	remove_dependent(field fun);
	cell*	make_application(field sub_fun, cell* eqn, const cstack& args, cell* bdy);

public:
		expr()
		{	
			if (!((int) (records = new field[heap_size]))) {
				cerr << "expr::expr - failed to allocate storage\n";
				exit(2);
			}
			unload();
		}

		~expr()
		{	delete[] records;	}

	int	occurs_in(cell* val, cell* exp);
	int	declare_type(field fun, cell* typ = (cell*) 0);

	int	exclude(field sel, cell* tuple);
	int	include(field sel, cell* tuple);
	int	selector(field sel, cell* type);
	int	function(field fun, cell* type);
	int	fetch_sel(char* file,cell* arg);
	int	pending(char* file,cell* arg);

	int	insert_eqn(field fun, cell* eqn);
	int	remove_eqns(field fun);
	int	fetch_exps(char* file, field fun);

	field	*dependencies(field fun, field results[], field *end, int down, field* next = 0);

	void	unload()
		{
			ptr = executable_code;
			next = 0;
		}

	field*	code(field fun, int eqn)
		{
			return (eqn < next && fun_name[eqn] == fun) ? fun_locn[eqn] : (field*) 0;
		}

	int	locate(char* file, field& fun, int order = True)
		{
			register int i;

			for (i = 0; (i < next) && (fun_name[i] != fun); ++i);
			return (i < next) ? i : load(file,fun,order);
		}

};
