//	exclude(s,t)		removes any tuples matching t from selector s.
//	------------

int	expr::exclude(field sel, cell* tuple)
{
	char	name[MaxString];
	field	saf[MaxArgs], *start, *end;

	(void) ast_rec(tuple,saf);
	for (int i = 0; i < saf[0].size(); ++i)
		if (saf[i] == AnyConst)
			saf[i].set(Any,0);
	strcpy(name,database->id_to_str(sel.value()));
	end = database->fetch(name,saf,records,records+heap_size);
	for (start = records; start < end; start += start->size())
		set_dependency(sel,start,-1);
	return database->remove(name,saf);
}

int	expr::remove_eqns(field fun)
{
	field	saf[4], records[MaxFunctions*4], *start, *end;
	char	string[MaxString];

	saf[0].set(Size1,4);
	saf[1] = fun;
	saf[2].set(Any,0);
	saf[3].set(Any,0);
	end = database->fetch("Depends",saf,records,records+(MaxFunctions*4));
	for (start = records; start < end; start += start->size()) {
		if (start[2].tag() == Var) {
			strcpy(string,database->id_to_str(start[2].value()));
			if (string[0] == '_')
				remove_eqns(start[2]);
		}
	}
	saf[0].set(Size1,3);
	saf[1] = fun;
	saf[2].set(Any,0);
	end = database->fetch("Equations",saf,records,records+heap_size);
	for (start = records; start < end; start += start->size())
		set_dependency(fun,start+2,-1);
	database->remove("Equations",saf);
	remove_dependent(fun);
	return end != records;
}

void	expr::remove_dependent(field fun)
{
	field	depends[MaxFunctions], *start, *end;

	end = dependencies(fun,depends,&(depends[MaxFunctions]),False);
	for (start = depends; start < end; ++start) {
		declare_type(*start);
		database->insert("Pending",start);
	}
}
