# pragma interface

class	cell {
private:
	char	u;				//	used
	field	d;				//	data
	cell*	l;				//	left
	cell*	r;				//	right
public:
		cell()
		{
			u = False;
		};
	char	used()
		{
			return u;
		};
	field	data()
		{
			return d;
		};
	char	tag()
		{
			return d.tag();
		};
	int	value()
		{
			return d.value();
		};
	float	valuef()
		{
			return d.valuef();
		};
	cell*	left()
		{
			return l;
		};
	cell*	right()
		{
			return r;
		};

	void	claim()
		{
			u = True;
		};
	void	release()
		{
			u = False;
		};

	cell&	set(field data,cell *left = (cell*) 0,cell *right = (cell*) 0)
		{
			u = True;
			d = data;
			l = left;
			r = right;
			return *this;
		};

	cell&	set(char tag,int value,cell *left = (cell*) 0,cell *right = (cell*) 0)
		{
			u = True;
			d.set(tag,value);
			l = left;
			r = right;
			return *this;
		};

	cell&	set(char tag, float value, cell *left = (cell*) 0, cell *right = (cell*) 0)
		{
			u = True;
			d.set(tag,value);
			l = left;
			r = right;
			return *this;
		};

	cell&	operator=(const cell& c)
		{	
			char	used =	c.u;		//	this is necessary since
			field	data =	c.d;		//	c might be referenced by
			cell*	left =	c.l;		//	this->left() or this->right()
			cell*	right =	c.r;

			u = used;
			d = data;
			l = left;
			r = right;
			return *this;
		};

	cell*	tip()
		{
			for (cell *root = this; root->tag() == App; root = root->left());
			return root;
		};

	int	whnf()
		{
			char t = this->tip()->tag();

			return (t != Sel1) && (t != Sel2) && (t != Var) && (t != Pre);
		}
};

ostream& operator<<(ostream& s, cell* e);
