# pragma interface

class	cstack {
private:
	int	top;
	int	size;
	cell*	*data;
public:
		 cstack(int sz)
		{
			top = 0;
			size = sz;
			if (!((int) (data = new cell* [sz]))) {
				cerr << "cstack::cstack - insufficient memory\n";
				exit(2);
			}
		};
	        cstack(const cstack& c) // make copy of a cstack
		{
		  top=c.top;
		  size=c.size;
		  if (!((int) (data = new cell* [size]))) {
		    cerr << "cstack::cstack(1) - insufficient memory\n";
		    exit(2);
		  }
		  for(int i=0; i<top; i++)
		    data[i]=c.data[i];
		}
		~cstack()
		{
			delete[] data;
		};
	int	used()
		{
			return top;
		};
	void	clear()
		{
			top = 0;
		};
	int	push(cell* v)	
		{
			if (v && (top < size))
				data[top++] = v;
			if (top == size)
				cout << "<< insufficient stack space (size = " << size << ") >>" << endl;
			return top < size;
		};
	cell*	pop()
		{
			return (top) ? (data[--top]) : ((cell*) 0);
		};

	void	operator=(cstack& s)
		{
			if (size != s.size) {
				cerr << "cstack::operator=\n";
				exit(1);
			}
			for (top = 0; top < s.top; ++top)
				data[top] = s.data[top];
		};

	cell*	operator[](int i)
		{
			if (i >= top) {
				cerr << "cstack::operator[]\n";
				exit(1);
			}
			return data[i];
		};

	cell*	unwind(register cell* root)
		{
			for (clear(); root->tag() == App; root = root->left())
				if (!push(root))
					exit(2);
			if (!push(root))
				exit(2);
			return root;
		}

};
