#pragma interface

extern	field	ConsConst;
extern	field	NilConst;
extern	field	LambdaConst;
extern	field	FlatmapVar;
extern	field	IfVar;

extern	int	heap_size;

class	hp {
private:
	int	free;
	cell*	front;
	cell*	data;
	cstack	safe;
	cstack	temp;
public:
		hp() : safe(heap_size/2), temp(heap_size/2)
		{
			free = heap_size;
			if (!((int) (front = data = new cell[heap_size]))) {
				cerr << "hp::hp - failed to allocate storage\n";
				exit(2);
			}
		};

		~hp()
		{	delete[] data;		};

	int	used()
		{	return safe.used();	};

	void	claim(cell* c)
		{	safe.push(c);	};

	cell*	release()
		{	return safe.pop();	};

	int	allocate(int);

	cell*	hp::make(char tag, int value, cell *left = (cell*) 0, cell *right = (cell*) 0)
	{
		register cell*	ptr;

		if (!(free || allocate(1))) {
			cerr << "hp::make\n";
			exit(2);
		}
		for (--free, ptr = front; ptr->used(); ++ptr);
		ptr->set(tag,value,left,right);
		return	front = ptr;
	}

	cell*	hp::make(field fld, cell *left = (cell*) 0, cell *right = (cell*) 0)
		{
			return make(fld.tag(),fld.value(),left,right);
		}

	cell*	hp::make_ast(register field* code, cstack& bindings)
		{
			cell	*right;
			char	tag;

			for (temp.clear(); (tag = code->tag()) != Load; ++code)
				switch (tag) {
				case App :
					right = temp.pop();
					temp.push(make(App,0,temp.pop(),right));
					break;
				case Arg :
					temp.push(bindings[code->value()]);
					break;
				default :
					temp.push(make(*code));
					break;
				}
			return temp.pop();
		}
};
