//	define(lhs,rhs)		adds the equation lhs = rhs to the database.
//	--------------	

int	oper::define(cell *lhs, cell *rhs)
{
	field	fun;
	cell	*eqn;

	if (!heap->allocate(MaxArgs*2))
		return False;
	for (eqn = rhs; lhs->tag() == App; lhs = lhs->left())
		eqn = heap->make(App,0,heap->make(App,0,heap->make(LambdaConst),lhs->right()),eqn);
	heap->claim(eqn);			//	protect the definition
	fun = lhs->data();
	if (fun.tag() != Var) {
		cout << "<< `" << database->id_to_str(fun.value()) << "' is not a variable >>" << endl << flush;
		heap->release();		//	unprotect the definition
		return False;
	}
	for (cell* curr = eqn; curr->tip()->data() == LambdaConst; curr = curr->right())
		if (!confirm_patt(curr->left()->right())) {
			cout << "<< --> " << curr->left()->right() << " <-- is not a pattern >>" << endl << flush;
			heap->release();	//	unprotect the definition
			return False;
		}
	expressions->insert_eqn(fun,eqn);
	types.cascade();
	heap->release();			//	unprotect the definition
	return True;
}

