//	extsel(f,t)	asserts that the type of f is t->[t].  t does not have to be protected.
//	-----------	selector deletes any tuples currently associated with f, deletes the 
//			existing type of f, and asserts that the new type of f is t

int	oper::extsel(field f, cell* t1)
{
	field	saf[MaxCells];
	cell*	t2;
	int	res;

	if (f.tag() != Sel1) {
		cout << "<< `" << heap->make(f) << "' is not an extensional selector >>" << endl << flush;
		return False;
	}
	if (!(types.monomorphic(t1) && types.first_order(t1))) {
		cout << "<< `" << heap->make(f) << "' is not monomorphic/first order >>" << endl << flush;
		return False;
	}
	heap->claim(t1);
	if (!heap->allocate(6)) {
		cout << "<< insufficient heap space >>" << endl << flush;
		heap->release();
		return False;
	}
	expressions->exclude(f,heap->make(Any,0));
	t2 = heap->make(App,0,heap->make(App,0,heap->make(FunConst),t1),heap->make(App,0,heap->make(ListConst),t1));
	heap->release();
	if (res = expressions->selector(f,t2))
		types.cascade();
	return	res;
}


