//	value(c,t)	Asserts that c is a value constructor of type t.
//	----------

int	oper::value(field c, cell* t)
{
	if (c.tag() != Con) {
		cout << "<< `" << database->id_to_str(c.value()) << "' is not a (value) constructor >>" << endl << flush;
		return False;
	}
	for (cell* ptr = t; ptr->tip()->data() == FunConst; ptr = ptr->right());
	if ((ptr = types.fetch(ptr))->data() != TypeConst) {
		cout << "<< `" << database->id_to_str(c.value());
		cout << "' constructs a `" << ptr << "' and not a `Type' >>" << endl << flush;
		return False;
	}
	if ((!types.existential(t)) && (!types.universal(t))) {
		cout << "<< `" << t << "' contains both existentially and universally quantified variables >>" << endl;
		return False;
	}
	return confirm_unused(c) ? expressions->declare_type(c,t) : False;
}

