# include       "../header.h"
# include       "../db/tc/tc.h"
# include       "../db/df/df.h"
# include       "../db/hf/hf.h"
# include       "../db/db.h"
# include       "../hp/cell.h"
# include       "../hp/cstack.h"
# include       "../hp/hp.h"
# include       "../user/user.h"
# include       "../expr/expr.h"
# include       "../type/type.h"

extern	type	types;

ostream& show_const(ostream& s, cell* exp);
ostream& show_func(ostream& s, cell* from, cell* to);
ostream& show_list(ostream& s, cell* exp);
ostream& show_product(ostream& s, cell* exp);

ostream& operator<<(ostream& s, cell* exp)
{
	cell* tip = exp->tip();
	char	string[MaxString];

	switch (exp->tag()) {
	case Con :
	case Chr :
	case Int :
	case Real :
	case Sel1 :
	case Sel2 :
	case Str :
	case TCon :
	case TVar :
	case Var :
		database->print(s,exp->data());
		return s;
	case Pre :
		return s << id_user(exp->data());
	case Lam :
		return s << "(\\" << exp->left() << "." << exp->right() << ")";
	default :
		switch (tip->tag()) {
		case Con :
			strcpy(string,database->id_to_str(tip->value()));
			if (strncmp("Product",string,7) == 0)
				return	show_product(s,exp);
			else if (strncmp("Tuple",string,5) == 0)
				return	show_product(s,exp);
			else if (strncmp("List",string,4) == 0)
				return	show_list(s,exp);
			else if (tip->data() == FunConst)
				return	show_func(s,exp->left()->right(),exp->right());
			else	return	show_const(s,exp);
		case Pre :
		case Sel1 :
		case Sel2 :
		case Var :
			return	show_const(s,exp);
		default :
			return s << "->" << tip->tag() << "<-";
		}
	}
}

ostream& show_func(ostream& s, cell* from, cell* to)
{
	if (!types.first_order(from))
		return s << "(" << from << ")->" << to;
	else	return s << from << "->" << to;
}

ostream& show_const(ostream& s, cell* exp)
{
	cstack	pending(MaxArgs);

	for (; exp->tag() == App; exp = exp->left())
		pending.push(exp->right());
	pending.push(exp);
	s << "(";
	while (exp = pending.pop())
		s << exp << " ";
	return	s << "\b)" << flush;
}

ostream& show_product(ostream& s, cell* exp)
{
	cstack	pending(MaxArgs);

	s << "(";
	for (; exp->tag() == App; exp = exp->left())
		pending.push(exp->right());
	while (exp = pending.pop())
		s << exp << ",";
	return	s << "\b)" << flush;
}

ostream& show_list(ostream& s, cell* exp)
{
	return	s << "[" << exp->right() << "]";
}
