# pragma interface
struct	bind {
	field		var;
	cell*		exp;
	struct bind	*next;
};

extern	hp	*heap;
extern	db	*database;
extern	expr	*expressions;

class	type {
private:
	bind*	env;
	int	nextv;
	int	nextc;

	int	fix(cell* old_type);
	int	infer(cell* exp, int binding);
	int	occurs(field var, cell* exp);

	int	new_variable()
		{
			return nextv++;
		}

	int	new_constructor()
		{
			return nextc++;
		}

	void	reset_env(bind* old)
		{
			for (bind* p = env; p != old; env = env->next, delete p, p = env);
		}

	cell*	standardise(cell* exp, int exist = False)
		{
			cstack s1(MaxArgs), s2(MaxArgs);

			return standardise(exp,exist,s1,s2);
		}

	cell*	standardise(cell* exp, int exist, cstack& s1, cstack& s2);

	int	substitute(field var, cell* exp)
		{
			bind*	temp = new bind;

			if (temp != (bind*) 0) {
				temp->var  = var;
				temp->exp  = exp;
				temp->next = env;
				env = temp;
			}
			return temp != (bind*) 0;
		}

	cell*	value(cell* exp)
		{
			for (bind* b = env; exp->tag() == TVar && b; b = b->next)
				if (exp->data() == b->var)
					exp = b->exp;
			return exp;
		}

	int	unify(cell* e1, cell* e2);
	int	size(cell* exp);

	void	cascade_fun(cell* fun);
	void	cascade_intsel(cell* sel);
	void	cascade_up(cell* fun);

public:
		type()
		{	env = (bind*) 0;	}

	int	first_order(cell* type);
	int	monomorphic(cell* t);
	int	existential(cell* c);
	int	universal(cell* c);

	void	cascade();
	cell*	fetch(cell* exp, int reset = True);
};
