extern	oper	*f;

//	compare		0,	Failure to evaluate
//	-------		1,	if no decision
//			2,	if e1 < e2
//			3,	if e1 == e2
//			4,	if e1 > e2

int	compare(cell* e1, cell* e2, cstack& pending)
{
	int	res;
	char	s1[MaxString], s2[MaxString];
	float	f1, f2;

	if (!e1->whnf())
		return	pending.push(e1);
	if (!e2->whnf())
		return	pending.push(e2);
	if (e1->tag() == App && e2->tag() == App) {
		if ((res = compare(e1->left(),e2->left(),pending)) != 3)
			return res;
		else	return compare(e1->right(),e2->right(),pending);
	}
	if (e1->data() == e2->data())
		return	3;
	if (e1->data() == AnyConst || e2->data() == AnyConst)
		return (e1->data() == AnyConst) ? 2 : 4;
	switch (e1->tag()) {
	case Int :
	case Real :
		if (e2->tag() != Int && e2->tag() != Real) {
			cout << "user::compare - unexpected tag" << endl;
			exit(1);
		}
		f1 = (e1->tag() == Int) ? e1->value() : e1->valuef();
		f2 = (e2->tag() == Int) ? e2->value() : e2->valuef();
		return (f1 == f2) ? 3 : ((f1 < f2) ? 2 : 4);
	case Str :
	case Con :
		if (e1->tag() != e2->tag())
			return (e1->tag() < e2->tag()) ? 2 : 4;
		else {
			strcpy(s1,database->id_to_str(e1->value()));
			strcpy(s2,database->id_to_str(e2->value()));
			return (strcmp(s1,s2) < 0) ? 2 : 4;
		}
	default :
		if (e1->tag() != e2->tag())
			return (e1->tag() < e2->tag()) ? 2 : 4;
		else	return (e1->value() < e2->value()) ? 2 : 4;
	}
}

int	equal(cstack& spine, cstack& pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res == 3) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	greater(cstack& spine, cstack &pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res == 4) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	lesser(cstack& spine, cstack& pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res == 2) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	not_equal(cstack& spine, cstack& pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res != 3) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	not_greater(cstack& spine, cstack& pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res != 4) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	not_lesser(cstack& spine, cstack& pending)
{
	int	res = compare(spine[1]->right(),spine[0]->right(),pending);

	if (res >= 2) {
		pending.pop();	//	The root will not need re-evaluation
		*spine[0] = (res != 2) ? *(heap->make(TrueConst)) : *(heap->make(FalseConst));
	}
	return	res;
}

int	match(cstack& spine, cstack& pending)
{
	cell	*arg1, *arg2;
	cstack	temp(MaxArgs*2);

	if (!temp.push(spine[0]->right()) || !temp.push(spine[1]->right()))
		return False;
	while ((arg1 = temp.pop()) && (arg2 = temp.pop())) {
		if (!arg1->whnf())
			return	pending.push(arg1);
		if (arg1->data() != AnyConst) {
			if (!arg2->whnf())
				return	pending.push(arg2);
			while (arg1->tag() == App && arg2->tag() == App) {
				if (!temp.push(arg2->right()) || !temp.push(arg1->right()))
					return False;
				arg2 = arg2->left();
				arg1 = arg1->left();
			}
			if (arg1->data() != arg2->data()) {
				*spine[0] = *(heap->make(FalseConst));
				return True;
			}
		}
	}
	*spine[0] = *(heap->make(TrueConst));
	return True;
}
