extern "C"	int	draw(char*);

int	clear(cstack& spine,cstack&)
{
	*spine[0] = draw("clr ") ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}

int	drawline(cstack& spine, cstack& pending)
{
	char	string[80];
	int	x1, x2, y1, y2;

	if (spine[0]->right()->tag() != Int && spine[0]->right()->tag() != Real)
		return	pending.push(spine[0]->right());
	if (spine[1]->right()->tag() != Int && spine[1]->right()->tag() != Real)
		return	pending.push(spine[1]->right());
	if (spine[2]->right()->tag() != Int && spine[2]->right()->tag() != Real)
		return	pending.push(spine[2]->right());
	if (spine[3]->right()->tag() != Int && spine[3]->right()->tag() != Real)
		return	pending.push(spine[3]->right());
	if (spine[0]->right()->tag() == Int)
		y2 = spine[0]->right()->value();
	else {
		cout << "<< non-integer y2 coordinate `" << spine[0]->right()->value() << "' >>";
		return False;
	}
	if (spine[1]->right()->tag() == Int)
		x2 = spine[1]->right()->value();
	else {
		cout << "<< non-integer x2 coordinate `" << spine[1]->right()->value() << "' >>";
		return False;
	}
	if (spine[2]->right()->tag() == Int)
		y1 = spine[2]->right()->value();
	else {
		cout << "<< non-integer y1 coordinate `" << spine[2]->right()->value() << "' >>";
		return False;
	}
	if (spine[3]->right()->tag() == Int)
		x1 = spine[3]->right()->value();
	else {
		cout << "<< non-integer x1 coordinate `" << spine[3]->right()->value() << "' >>";
		return False;
	}
	sprintf(string,"line %d %d %d %d ",x1,y1,x2,y2);
	*spine[0] = draw(string) ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}

int	drawarc(cstack& spine, cstack& pending)
{
	char	string[80];
	int	x, y, width, height, start, end;

	if (spine[0]->right()->tag() != Int && spine[0]->right()->tag() != Real)
		return	pending.push(spine[0]->right());
	if (spine[1]->right()->tag() != Int && spine[1]->right()->tag() != Real)
		return	pending.push(spine[1]->right());
	if (spine[2]->right()->tag() != Int && spine[2]->right()->tag() != Real)
		return	pending.push(spine[2]->right());
	if (spine[3]->right()->tag() != Int && spine[3]->right()->tag() != Real)
		return	pending.push(spine[3]->right());
	if (spine[4]->right()->tag() != Int && spine[4]->right()->tag() != Real)
		return	pending.push(spine[4]->right());
	if (spine[5]->right()->tag() != Int && spine[5]->right()->tag() != Real)
		return	pending.push(spine[5]->right());
	if (spine[0]->right()->tag() == Int)
		end = spine[0]->right()->value();
	else {
		cout << "<< non-integer end coordinate `" << spine[0]->right()->value() << "' >>";
		return False;
	}
	if (spine[1]->right()->tag() == Int)
		start = spine[1]->right()->value();
	else {
		cout << "<< non-integer start coordinate `" << spine[1]->right()->value() << "' >>";
		return False;
	}
	if (spine[2]->right()->tag() == Int)
		height = spine[2]->right()->value();
	else {
		cout << "<< non-integer height coordinate `" << spine[2]->right()->value() << "' >>";
		return False;
	}
	if (spine[3]->right()->tag() == Int)
		width = spine[3]->right()->value();
	else {
		cout << "<< non-integer width coordinate `" << spine[3]->right()->value() << "' >>";
		return False;
	}
	if (spine[4]->right()->tag() == Int)
		y = spine[4]->right()->value();
	else {
		cout << "<< non-integer y coordinate `" << spine[4]->right()->value() << "' >>";
		return False;
	}
	if (spine[5]->right()->tag() == Int)
		x = spine[5]->right()->value();
	else {
		cout << "<< non-integer x coordinate `" << spine[5]->right()->value() << "' >>";
		return False;
	}
	sprintf(string,"arc %d %d %d %d %d %d ",x,y,width,height,start,end);
	*spine[0] = draw(string) ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}

int	drawstring(cstack& spine, cstack& pending)
{
	char	string[80], message[80];
	int	x, y;

	if (spine[0]->right()->tag() != Str)
		return	pending.push(spine[0]->right());
	if (spine[1]->right()->tag() != Int && spine[1]->right()->tag() != Real)
		return	pending.push(spine[1]->right());
	if (spine[2]->right()->tag() != Int && spine[2]->right()->tag() != Real)
		return	pending.push(spine[2]->right());
	if (spine[0]->right()->tag() == Str)
		strcpy(message,database->id_to_str(spine[0]->right()->value()));
	if (spine[1]->right()->tag() == Int)
		y = spine[1]->right()->value();
	else {
		cout << "<< non-integer y coordinate `" << spine[1]->right()->value() << "' >>";
		return False;
	}
	if (spine[2]->right()->tag() == Int)
		x = spine[2]->right()->value();
	else {
		cout << "<< non-integer x coordinate `" << spine[2]->right()->value() << "' >>";
		return False;
	}
	sprintf(string,"strg %d %d \"%s\"",x,y,message);
	*spine[0] = draw(string) ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}

int	drawpoint(cstack& spine, cstack& pending)
{
	char	string[80];
	int	x, y;

	if (spine[0]->right()->tag() != Int && spine[0]->right()->tag() != Real)
		return	pending.push(spine[0]->right());
	if (spine[1]->right()->tag() != Int && spine[1]->right()->tag() != Real)
		return	pending.push(spine[1]->right());
	if (spine[0]->right()->tag() == Int)
		y = spine[0]->right()->value();
	else {
		cout << "<< non-integer y coordinate `" << spine[0]->right()->value() << "' >>";
		return False;
	}
	if (spine[1]->right()->tag() == Int)
		x = spine[1]->right()->value();
	else {
		cout << "<< non-integer x coordinate `" << spine[1]->right()->value() << "' >>";
		return False;
	}
	sprintf(string,"pnt %d %d ",x,y);
	*spine[0] = draw(string) ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}

int	drawspline(cstack& spine,cstack&)
{
	*spine[0] = draw("spln") ? *heap->make(TrueConst) : *heap->make(FalseConst);
	return True;
}
