# pragma implementation

# include	"../header.h"
# include	"../db/tc/tc.h"
# include	"../db/df/df.h"
# include	"../db/hf/hf.h"
# include	"../db/db.h"
# include	"../hp/cell.h"
# include	"../hp/cstack.h"
# include	"../hp/hp.h"
# include	"../expr/expr.h"
# include	"../type/type.h"
# include	"../user/user.h"
# include	"../eval/eval.h"
# include	"../oper/oper.h"

char *fun_names[] =	{							//		(i)	add the name as it is to be parsed
	"(%)",
	"(/)",
	"(div)",
	"(-)",
	"(*)",
	"(+)",
	"(?=)",
	"(=)",
	"(>)",
	"(<)",
	"(!=)",
	"(<=)",
	"(>=)",
	"tostr",
	"strchrs",
	"chrsstr",
	"numchrs",
	"chrsnum",
	"flatmap",
	"foldr",
	"when",
	"encode",
	"decode",
	"strict",
	"type_of",
	"error",
//	"clear",
//	"drawline",
//	"drawarc",
//	"drawstring",
//	"drawspline",
//	"drawpoint",
	""
};

typedef int	(*SysFun)(cstack& spine, cstack& pending);

extern	int	modulus(cstack& spine, cstack& pending);			//		(ii)	add an external declaration for the C++ function
extern	int	divider(cstack& spine, cstack& pending);
extern	int	dividei(cstack& spine, cstack& pending);
extern	int	minus(cstack& spine, cstack& pending);
extern	int	multiply(cstack& spine, cstack& pending);
extern	int	plus(cstack& spine, cstack& pending);
extern	int	match(cstack& spine, cstack& pending);
extern	int	equal(cstack& spine, cstack& pending);
extern	int	greater(cstack& spine, cstack& pending);
extern	int	lesser(cstack& spine, cstack& pending);
extern	int	not_equal(cstack& spine, cstack& pending);
extern	int	not_greater(cstack& spine, cstack& pending);
extern	int	not_lesser(cstack& spine, cstack& pending);
extern	int	tostr(cstack& spine, cstack& pending);
extern	int	strchrs(cstack& spine, cstack& pending);
extern	int	chrsstr(cstack& spine, cstack& pending);
extern	int	numchrs(cstack& spine, cstack& pending);
extern	int	chrsnum(cstack& spine, cstack& pending);
extern	int	flatmap(cstack& spine, cstack& pending);
extern	int	foldr(cstack& spine, cstack& pending);
extern	int	when(cstack& spine, cstack& pending);
extern	int	encode(cstack& spine, cstack& pending);
extern	int	decode(cstack& spine, cstack& pending);
extern	int	strict(cstack& spine, cstack& pending);
extern	int	type_of(cstack& spine, cstack& pending);
extern	int	error(cstack& spine, cstack& pending);
// extern	int	clear(cstack& spine, cstack& pending);
// extern	int	drawline(cstack& spine, cstack& pending);
// extern	int	drawarc(cstack& spine, cstack& pending);
// extern	int	drawstring(cstack& spine, cstack& pending);
// extern	int	drawspline(cstack& spine, cstack& pending);
// extern	int	drawpoint(cstack& spine, cstack& pending);

SysFun functions[] =	{							//		(iii)	add the C++ function name
	modulus,
	divider,
	dividei,
	minus,
	multiply,
	plus,
	match,
	equal,
	greater,
	lesser,
	not_equal,
	not_greater,
	not_lesser,
	tostr,
	strchrs,
	chrsstr,
	numchrs,
	chrsnum,
	flatmap,
	foldr,
	when,
	encode,
	decode,
	strict,
	type_of,
	error
//	,clear,
//	drawline,
//	drawarc,
//	drawstring,
//	drawspline,
//	drawpoint
};

int	arguments[] =	{							//		(iv)	add the size of the spine for the application
	3,	// modulus
	3,	// divider
	3,	// dividei
	3,	// minus
	3,	// multiply
	3,	// plus
	3,	// match
	3,	// equal
	3,	// greater
	3,	// lesser
	3,	// not_equal
	3,	// not_greater
	3,	// not_lesser
	2,	// tostr
	2,	// strchrs
	2,	// chrsstr
	2,	// numchrs
	2,	// chrsnum
	3,	// flatmap
	4,	// foldr
	4,	// when
	2,	// encode
	2,	// decode
	3,	// strict
	2,	// type_of
	2,	// error
//	1,	// clear
//	5,	// drawline
//	7,	// drawarc
//	4,	// drawstring
//	1,	// drawspline
//	3,	// drawpoint
};

# include	"modulus.C"							//		(v)	include the code
# include	"divide.C"
# include	"minus.C"
# include	"multiply.C"
# include	"plus.C"
# include	"compare.C"
# include	"tostr.C"
# include	"strchrs.C"
# include	"numchrs.C"
# include	"flatmap.C"
# include	"foldr.C"
# include	"when.C"
# include	"encode.C"
# include	"decode.C"
# include	"strict.C"
# include	"typeof.C"
# include	"error.C"
/* # include	"draw.C" */

int	user_id(char *name)
{
	for (int i = 0; (strlen(fun_names[i]) != 0) && (strcmp(fun_names[i],name) != 0); ++i);
	return (strlen(fun_names[i]) == 0) ? (-1) : i;
}

const char* id_user(field f)
{
	check(f.tag() == Pre,"user::id_user");
	return fun_names[f.value()];
}

int	exec(int fun, cstack& spine, cstack& pending)
{
	if (spine.used() < arguments[fun]) {
		cout << "<< function >>";
		return False;
	}
	else	return functions[fun](spine,pending);
}

